searchNodes=[{"type":"behaviour","title":"ElixirMake.Precompiler","doc":"The behaviour for precompiler modules.","ref":"ElixirMake.Precompiler.html"},{"type":"callback","title":"ElixirMake.Precompiler.all_supported_targets/1","doc":"This callback should return a list of triplets (&quot;arch-os-abi&quot;) for all supported targets of the given operation. For the :compile operation, all_supported_targets should return a list of targets that the current host is capable of (cross-)compiling to. For the :fetch operation, all_supported_targets should return the full list of targets. For example, GitHub Actions provides Linux, macOS and Windows CI hosts, when operation is :compile , the precompiler might return [&quot;x86_64-linux-gnu&quot;] if it is running in the Linux CI environment, while returning [&quot;x86_64-apple-darwin&quot;, &quot;aarch64-apple-darwin&quot;] on macOS, or [&quot;amd64-windows&quot;, &quot;x86-windows&quot;] on Windows platform. When operation is :fetch , the precompiler should return the full list. The full list for the above example should be: [ &quot;x86_64-linux-gnu&quot; , &quot;x86_64-apple-darwin&quot; , &quot;aarch64-apple-darwin&quot; , &quot;amd64-windows&quot; , &quot;x86-windows&quot; ] This allows the precompiler to do the compilation work in multilple hosts and gather all the artefacts later with mix elixir_make.checksum --all .","ref":"ElixirMake.Precompiler.html#c:all_supported_targets/1"},{"type":"callback","title":"ElixirMake.Precompiler.build_native/1","doc":"This callback will be invoked when the user executes the mix compile (or mix compile.elixir_make ) command. The precompiler should then compile the NIF library &quot;natively&quot;. Note that it is possible for the precompiler module to pick up other environment variables like TARGET_ARCH=aarch64 and adjust compile arguments correspondingly.","ref":"ElixirMake.Precompiler.html#c:build_native/1"},{"type":"callback","title":"ElixirMake.Precompiler.current_target/0","doc":"This callback should return the target triplet for current node.","ref":"ElixirMake.Precompiler.html#c:current_target/0"},{"type":"function","title":"ElixirMake.Precompiler.mix_compile/1","doc":"Invoke the regular Mix toolchain compilation.","ref":"ElixirMake.Precompiler.html#mix_compile/1"},{"type":"callback","title":"ElixirMake.Precompiler.post_precompile/0","doc":"Optional post actions to run after all precompilation tasks are done. It will only be called at the end of the mix elixir_make.precompile command. For example, actions can be archiving all precompiled artefacts and uploading the archive file to an object storage server.","ref":"ElixirMake.Precompiler.html#c:post_precompile/0"},{"type":"callback","title":"ElixirMake.Precompiler.post_precompile_target/1","doc":"Optional post actions to run after each precompilation target is archived. It will be called when a target is precompiled and archived successfully. For example, actions can be deleting all target-specific files.","ref":"ElixirMake.Precompiler.html#c:post_precompile_target/1"},{"type":"callback","title":"ElixirMake.Precompiler.precompile/2","doc":"This callback should precompile the library to the given target(s). Returns :ok if the requested target has successfully compiled.","ref":"ElixirMake.Precompiler.html#c:precompile/2"},{"type":"callback","title":"ElixirMake.Precompiler.unavailable_target/1","doc":"Optional recover actions when the current target is unavailable. There are two reasons that the current target might be unavailable: when the library only has precompiled binaries for some platforms, and it either needs to be compiled on other platforms. The callback should return :compile for this case. is intended to function as noop on other platforms. The callback should return :ignore for this case. Defaults to :compile if this callback is not implemented.","ref":"ElixirMake.Precompiler.html#c:unavailable_target/1"},{"type":"type","title":"ElixirMake.Precompiler.target/0","doc":"Target triplet.","ref":"ElixirMake.Precompiler.html#t:target/0"},{"type":"task","title":"Mix.Tasks.Compile.ElixirMake","doc":"Runs make in the current project. This task runs make in the current project; any output coming from make is printed in real-time on stdout. Configuration This compiler can be configured through the return value of the project/0 function in mix.exs ; for example: def project ( ) do [ app : :myapp , make_executable : &quot;make&quot; , make_makefile : &quot;Othermakefile&quot; , compilers : [ :elixir_make ] ++ Mix . compilers , deps : deps ( ) ] end The following options are available: :make_executable - (binary or :default ) it's the executable to use as the make program. If not provided or if :default , it defaults to &quot;nmake&quot; on Windows, &quot;gmake&quot; on FreeBSD, OpenBSD and NetBSD, and &quot;make&quot; on everything else. You can, for example, customize which executable to use on a specific OS and use :default for every other OS. If the MAKE environment variable is present, that is used as the value of this option. :make_makefile - (binary or :default ) it's the Makefile to use. Defaults to &quot;Makefile&quot; for Unix systems and &quot;Makefile.win&quot; for Windows systems if not provided or if :default . :make_targets - (list of binaries) it's the list of Make targets that should be run. Defaults to [] , meaning make will run the first target. :make_clean - (list of binaries) it's a list of Make targets to be run when mix clean is run. It's only run if a non- nil value for :make_clean is provided. Defaults to nil . :make_cwd - (binary) it's the directory where make will be run, relative to the root of the project. :make_env - (map of binary to binary) it's a map of extra environment variables to be passed to make . You can also pass a function in here in case make_env needs access to things that are not available during project setup; the function should return a map of binary to binary. Many default environment variables are set, see section below :make_error_message - (binary or :default ) it's a custom error message that can be used to give instructions as of how to fix the error (e.g., it can be used to suggest installing gcc if you're compiling a C dependency). :make_args - (list of binaries) it's a list of extra arguments to be passed. The following options configure precompilation: :make_precompiler - a two-element tuple with the precompiled type and module to use. The precompile type is either :nif or :port and then the precompilation module. If the type is a :nif , it looks for a DDL or a shared object as precompilation target given by :make_precompiler_filename and the current NIF version is part of the precompiled archive. If :port , it looks for an executable with :make_precompiler_filename . :make_precompiler_url - the download URL template. Defaults to none. Required when make_precompiler is set. :make_precompiler_filename - the filename of the compiled artefact without its extension. Defaults to the app name. :make_force_build - if build should be forced even if precompiled artefacts are available. Defaults to true if the app has a -dev version flag. See the Precompilation guide for more information. Default environment variables There are also several default environment variables set: MIX_TARGET MIX_ENV MIX_BUILD_PATH - same as Mix.Project.build_path/0 MIX_APP_PATH - same as Mix.Project.app_path/0 MIX_COMPILE_PATH - same as Mix.Project.compile_path/0 MIX_CONSOLIDATION_PATH - same as Mix.Project.consolidation_path/0 MIX_DEPS_PATH - same as Mix.Project.deps_path/0 MIX_MANIFEST_PATH - same as Mix.Project.manifest_path/0 ERL_EI_LIBDIR ERL_EI_INCLUDE_DIR ERTS_INCLUDE_DIR ERL_INTERFACE_LIB_DIR ERL_INTERFACE_INCLUDE_DIR These may also be overwritten with the make_env option. Compilation artifacts and working with priv directories Generally speaking, compilation artifacts are written to the priv directory, as that the only directory, besides ebin , which are available to Erlang/OTP applications. However, note that Mix projects supports the :build_embedded configuration, which controls if assets in the _build directory are symlinked (when false , the default) or copied ( true ). In order to support both options for :build_embedded , it is important to follow the given guidelines: The &quot;priv&quot; directory must not exist in the source code The Makefile should copy any artifact to $MIX_APP_PATH/priv or, even better, to $MIX_APP_PATH/priv/$MIX_TARGET If there are static assets, the Makefile should copy them over from a directory at the project root (not named &quot;priv&quot;)","ref":"Mix.Tasks.Compile.ElixirMake.html"},{"type":"task","title":"Mix.Tasks.ElixirMake.Checksum","doc":"A task responsible for downloading the precompiled NIFs for a given module. This task must only be used by package creators who want to ship the precompiled NIFs. The goal is to download the precompiled packages and generate a checksum to check-in alongside the project in the the Hex repository. This is done by passing the --all flag. You can also use the --only-local flag to download only the precompiled package for use during development. You can use the --ignore-unavailable flag to ignore any NIFs that are not available. This is useful when you are developing a new NIF that does not support all platforms. This task also accept the --print flag to print the checksums.","ref":"Mix.Tasks.ElixirMake.Checksum.html"},{"type":"task","title":"Mix.Tasks.ElixirMake.Precompile","doc":"Precompiles the given project for all targets. This task must only be used by package creators who want to ship the precompiled NIFs. This task is often used on CI to precompile for different targets. This is only supported if :make_precompiler is specified in your project configuration.","ref":"Mix.Tasks.ElixirMake.Precompile.html"}]